********************************************************

* PRGR - PROGRAM TO SEND GRAPHICS CHARACTERS

* FROM DISK FILE TO LISTING DEVICE.

* 11-JUL-84	UPDATE FOR V5.1 UPCUL1 GRAPHICS

*

BDOS	EQU	5	; CP/M ENTRY

CONOUT	EQU	2	; CONSOLE OUTPUT

LSTOUT	EQU	5	; LISTING OUTPUT

DCIO	EQU	6	; DIRECT CONSOLE I/O

PRSTR	EQU	9	; PRINT STRING TO $

RDCBUF	EQU	10	; READ CONSOLE BUFFER

*

BS	EQU	8

LF	EQU	10

CR	EQU	13

CTRLZ	EQU	26

ESC	EQU	27

BDOS	EQU	5

OPEN	EQU	15

READ	EQU	20

SETDMA	EQU	26

FCB1	EQU	5CH

FCB1CR	EQU	FCB1+32

	ORG	0100H

	MVI	C,PRSTR ; PRINT OPENING MESSAGE

	LXI	D,MSG	; AND CLEAR SCREEN

	CALL	BDOS

* FIX LPTOUT ADDRESS

	LXI	H,LPTOUT

	SHLD	LPT

*

*  LOOP READING AND WRITING CHARACTERS

	MVI	C,OPEN

	LXI	D,FCB1

	CALL	BDOS	; OPEN

	INR	A

	JZ	ERR1

	XRA	A

	STA	FCB1CR

	MVI	C,SETDMA

	LXI	D,BUFR

	CALL	BDOS

DOREAD: MVI	C,READ

	LXI	D,FCB1

	CALL	BDOS

	ORA	A

	JNZ	XIT

	LXI	H,BUFR

	MVI	D,128

SEND:	MOV	C,M

	MVI	A,CTRLZ ; END OF FILE MARK

	CMP	C

	JZ	XIT

	PUSH	H

	PUSH	D

;	PUSH	B	;#

;	MOV	E,C	;# SEND TO

;	MVI	C,CONOUT;# CONSOLE

;	CALL	BDOS	;# FOR DEBUG

;	POP	B	;#

	CALL	DBD

	POP	D

	POP	H

	INX	H

	DCR	D

	JNZ	SEND

	JMP	DOREAD

*

* RETURN TO CP/M

ERR1:	MVI	C,PRSTR

	LXI	D,ERMSG

	CALL	BDOS

XIT:	JMP	0

*

LPTOUT: MOV	E,C

	MVI	C,LSTOUT

	JMP	BDOS	; RETURN IS ON THE STACK

*

* DATA SPACE

ERMSG	DB	'ERROR - INPUT FILE NOT FOUND',CR,LF,'$'

MSG	DB	'UPC Graphic Print Program',CR,LF

	DB	'(C)1984 by Lindley Systems',CR,LF,LF,'$'

BUFR	DS	128

* LINKS

LPT	EQU	$+8	; LINK GRAPHIC OUTPUT TO LPTOUT

DBD	EQU	$+10	; LINK TO GRAPHIC PRINT

* JOINED TO UPCUL1.ASM AT THIS POINT

ORA	A

	RZ		; SKIP NULLS

	LDA	LGST	; STAT